library indicator;

import 'dart:core';
import 'api.dart';
import 'function.dart';
import 'variables.dart';
import 'dart:developer';
import 'package:geiger_api/geiger_api.dart';
import 'package:geiger_localstorage/geiger_localstorage.dart';

Future runIndicator(var indicatorID) async {
  final localMaster =
  (await getGeigerApi("", GeigerApi.masterId, Declaration.doNotShareData))
  !;
  Storage.controller = localMaster.getStorage();
  Storage.geigerIndicatorUUID = indicatorID;
  log("=======================indicator ID"+ Storage.geigerIndicatorUUID);

  await createPlugin();
  await createLocal();

  await initPlugin(); //check exist of mertic data
  await setValueListener(); //Init Listener
  await checkExistNodes();

  await getRisk(); //global data
  await getRecommendation(); //global data

  log(Storage.getValuePath.length.toString());

  await getMetrics(Types.users, Storage.userUUID);
  await updateScoreNode(Types.users, Types.geigerScoreUser);
  await updateRecommendationNode(Types.users);

  await getMetrics(Types.devices, Storage.deviceUUID);
  await updateScoreNode(Types.devices, Types.geigerScoreDevice);
  await updateRecommendationNode(Types.devices);

  await getDevices();
  await getEmployees();
  await crtAggregateScore();
  await updateScoreNode(Types.users, Types.geigerScoreAggregate);

  updateScoreMSENode();

}




Future createPlugin() async{

  //:Local:plugin
  Node plugins = NodeImpl(':Local:plugin','');
//  try {
//    await Storage.controller!.addOrUpdate(plugins);
//  } catch (e, s) {
//    print(e);
//  }

  // final input =  File(dirname(Platform.script.path)+'/test/dummyAPI/dummydata/local.csv').openRead();
  // final fields = await input.transform(utf8.decoder).transform(CsvToListConverter()).toList();

  for ( var object in local){

    try {

      Node temp = NodeImpl(object['UUID']!,'',':Local:plugin');
      await temp.addValue(NodeValueImpl('appname', object['Name']!));
      await temp.addValue(NodeValueImpl('company', object['company']!));
      await plugins.addChild(temp);

    }
    catch(e){
      log(e.toString());
    }
  }

  await Storage.controller!.addOrUpdate(plugins);
  //print(await Storage.controller!.get(':Local:plugin'));
}


var local = [{
  "company": "ATOS",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a1",
  "Name": "ATOS RAE"
}, {
  "company": "Montimage",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a2",
  "Name": "IDS"
}, {
  "company": "Montimage",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a3",
  "Name": "CyberRange 1"
}, {
  "company": "Montimage",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a4",
  "Name": "CyberRange 2"
}, {
  "company": "Montimage",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a5",
  "Name": "Penetration Testing"
}, {
  "company": "Kaspersky",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a6",
  "Name": "KMS-SDK"
}, {
  "company": "Kaspersky",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a7",
  "Name": "CSMG"
}, {
  "company": "KPMG",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a8",
  "Name": "GDPR"
}, {
  "company": "KPMG",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a9",
  "Name": "Doc-Harvest"
}, {
  "company": "KPMG",
  "UUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a10",
  "Name": "Fraud-detection"
}];
